﻿using System;
using System.Collections.Generic;

class AnimalWordle
{
    static void Main()
    {
        Console.WriteLine("Welcome to Animal Wordle!");
        Console.WriteLine();
        Console.WriteLine("Wordle is a word game that was created and developed by Welsh software engineer\r\nJosh Wardle. In the original version of Wordle, players have six attempts to guess\r\na five-letter word, with feedback given for each guess in the form of coloured\r\ntiles indicating when letters match or occupy the correct position.");
        Console.WriteLine();
        Console.WriteLine("In Animal Wordle, players have six attempts to guess a four-letter animal, with\r\nfeedback given for each guess indicating when letters match or occupy the correct\r\nposition. If the character is in the correct position, it is indicated with a hash\r\n(#). If a character is correct, but in the wrong position, it is indicated with a\r\nhyphen (-). If a character is incorrect, it is represented with a full stop (.).");
        Console.WriteLine();



        //animal list
        List<string> animals = new List<string> { "duck", "goat", "bear", "lion", "frog", "deer", "swan", "wolf", "crab" };
        string name;

        while (true)
        {
            // Ask the user for their name
            Console.Write("Please enter your name: ");
            name = Console.ReadLine();

            //Ensures user acutally inputs their name
            if (string.IsNullOrEmpty(name))
            {
                Console.WriteLine("Try again");
            }

            else
            {
                break;
            }
        }
        while (true)
        {
            Console.WriteLine($"Hi {name}! Would you like to play Wordle? [y/n]: ");
            string playResponse = Console.ReadLine().ToLower();
            //checks to see if the player input a correct response
            if (playResponse == "y" || playResponse == "n")
            {
                if (playResponse != "y")
                {
                    Console.WriteLine("Ok... bye then.");
                    return;
                }
                else
                {
                    break;
                }
            }
            else
            {
                Console.WriteLine("Please enter either y or n");
            }
        }


        // Selects a random animal
        Random random = new Random();
        string secretAnimal = animals[random.Next(animals.Count)];
        int maxAttempts = 6;
        int attemptsRemaining = maxAttempts;

        Console.WriteLine($"You have {attemptsRemaining} guesses left.");

        //loops the game while the players still has guess remainng
        while (attemptsRemaining > 0)
        {
            Console.WriteLine("Please enter your four-letter guess:");
            char[] guess = new char[4];

            // Taking input one letter at a time
            for (int i = 0; i < 4; i++)
            {
                Console.Write($"Letter {i + 1}: ");
                string input = Console.ReadLine().ToLower();

                // Validate that the input is a single letter
                while (input.Length != 1 || !char.IsLetter(input[0]))
                {
                    Console.Write("Please enter a valid single letter.\r\n");

                    Console.Write($"Letter {i + 1}: ");

                    input = Console.ReadLine().ToLower();
                }

                guess[i] = input[0];
            }

            // Generates feedback
            string feedback = PlayerFeedback(secretAnimal, guess);

            Console.WriteLine($"Result: {feedback}");

            if (feedback == "####")
            {
                Console.WriteLine("Woohoo! You guessed the word correctly!");
                return;
            }

            attemptsRemaining--;
            if (attemptsRemaining > 0)
            {
                Console.WriteLine("Getting there! Keep guessing!");
                Console.WriteLine($"You have {attemptsRemaining} guesses left.");
            }
            else
            {
                Console.WriteLine("Sorry, you're out of guesses!");
                Console.WriteLine($"The correct word was: {secretAnimal}");
            }
        }
    }

    //Method to match the guessed letters with a response
    static string PlayerFeedback(string secret, char[] guess)
    {
        char[] feedback = new char[4];

        for (int i = 0; i < 4; i++)
        {
            if (guess[i] == secret[i])
            {
                feedback[i] = '#';  
            }
            else if (secret.Contains(guess[i]))
            {
                feedback[i] = '-';  
            }
            else
            {

                feedback[i] = '.';  
            }
        }

        return new string(feedback);
    }
}
